import re
import os
import socket
import threading
import time

ip='218.104.194.130'
port=43215
source='selfplay_data'  
packsize=64      #the number of files that 1 '*.tar' file contain

maxthread=5  
sleeptime=3 #I will try to change it dynamically 
alpha=0.8 #maybe moving average?
#if there are many threads sending at the same time,they may be slow together

delete_command='rm'+' '  #'del ' for windows, 'rm ' for linux
packlist=[]
packindex=0    
tempdir='sendTempFile'

if not os.path.exists(tempdir):
    os.system('mkdir '+tempdir)
    print('[info] create dir:'+tempdir)


def getPrefix(path):
    '''
    get prefix
    '''
    filelist=os.listdir(source)
    prefix={}
    for f in filelist:
        matchResult=re.match(r'(agz9_selfplay_zhuque_([-A-Za-z1-9]+)_mlu\d_)(\d+)\.moves',f)
        if not matchResult:
            continue
        pre=matchResult.group(1)
        index=int(matchResult.group(3))
        if pre in prefix:
            prefix[pre]=min(prefix[pre],index)
        else:
            prefix[pre]=index
    return prefix
        


def sendFileThread(ip, port,packlist,packindex):  
    packname='tempPack'+str(packindex)+'.tar'
    out='sending '+packname+'...'
    comm='tar -C '+source+' -cf '+os.path.join(tempdir,packname)
    for f in packlist:
        comm+=' '+f
    os.system(comm)
    while True:
        time_start=time.time()
        try:
            client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            client.connect((ip, port))
            client.send(packname.encode())
            respond = client.recv(10)
            if respond == b'ACK':
                with open(os.path.join(tempdir,packname), 'rb') as f:
                    while True:
                        part = f.read(2048)
                        if not part:
                            break
                        client.sendall(part)
        except Exception as e:
            print(e)
            print(out+'retry')
        else:
            client.close()
            time_end=time.time()
            global sleeptime
            print(out+'done!total time={:.3f} sec,sleep time={:.3f} sec'.format(time_end-time_start,sleeptime))
            # maybe I can use conn time to change sleeptime dynamically?
            sleeptime=min(5,alpha*sleeptime+(1-alpha)*(time_end-time_start)*1.375)
            os.system(delete_command+os.path.join(tempdir,packname))
            break

runMainLoop=True
def listenforkeyboard():
    while True:
        aaa=input('[info] input <quit/exit> can quit:\n')
        print('you input:'+aaa)
        if aaa=='quit' or aaa=='exit':
            global runMainLoop
            runMainLoop=False
            break

a=''
while not (a=='Y' or a=='y'):
    prefix=getPrefix(source)
    print('{} prefixes had found'.format(len(prefix)))
    a=input('start sending?<Y or y> :')

t = threading.Thread(target=listenforkeyboard)
t.start() 

while runMainLoop:   
    for key in prefix:
        if len(threading.enumerate()) >= maxthread:
            continue

        path=os.path.join(source,key+str(prefix[key])+'.moves.finish')
        if os.path.exists(path):
            filename=key+str(prefix[key])+'.moves'
            packlist.append(filename)
            if len(packlist)==packsize:
                if packindex>1000:
                    packindex=0
                t = threading.Thread(target=sendFileThread, args=(ip, port,packlist,packindex))
                t.setDaemon(True) #thread will end when main thread end
                t.start()   
                packlist=[]     
                packindex+=1    
                time.sleep(sleeptime) #wait for the socket connected
            prefix[key]+=1
    
print('[info] stop and exit! will delete temp file (or not)!')
print('[info] and all the thread will end (dont know what will happen)')
