import re
import os
import socket
import threading
import time


port=43215
source='selfplay_data'  
packsize=64      #the number of files that 1 '*.tar' file contain


packindex=0    #index for tar
maxindex=10000
tempdir='sendTempFile'
waitinglist=[]
maxExistTempFile=25
delete_command='rm'+' '  #'del ' for windows, 'rm ' for linux

if not os.path.exists(tempdir):
    os.system('mkdir '+tempdir)
    print('[info] create dir:'+tempdir)


def getPrefix(path):
    '''
    get prefix
    '''
    filelist=os.listdir(source)
    prefix={}
    for f in filelist:
        matchResult=re.match(r'(agz9_selfplay_zhuque_([-A-Za-z1-9]+)_mlu\d_)(\d+)\.moves',f)
        if not matchResult:
            continue
        pre=matchResult.group(1)
        index=int(matchResult.group(3))
        if pre in prefix:
            prefix[pre]=min(prefix[pre],index)
        else:
            prefix[pre]=index
    return prefix

def tarFileThread():
    global packindex
    global prefix  
    global waitinglist
    packlist=[]
    while True:
        for key in prefix:
            if len(waitinglist)>maxExistTempFile:
                continue
            path=os.path.join(source,key+str(prefix[key])+'.moves.finish')
            if os.path.exists(path):
                filename=key+str(prefix[key])+'.moves'
                packlist.append(filename)
                if len(packlist)==packsize:
                    packname='tempPack'+str(packindex)+'.tar'
                    comm='tar -C '+source+' -cf '+os.path.join(tempdir,packname)
                    for f in packlist:
                        comm+=' '+f
                    os.system(comm)
                    waitinglist.append(packname)
                    packlist=[]     
                    packindex+=1    
                    if packindex>maxindex:
                        packindex=0                    
                prefix[key]+=1    



def sendThread(sock,packname):
    global waitinglist
    while True:
        time_start=time.time()
        try:
            if not packname:
                print('no zip file to send yet!')
                sock.send('wait'.encode())
                break
            out='sending '+packname+'...'
            sock.send(packname.encode())
            respond = sock.recv(10)
            if respond == b'ACK':
                with open(os.path.join(tempdir,packname), 'rb') as f:
                    while True:
                        part = f.read(8192)
                        if not part:
                            break
                        sock.sendall(part)
                    sock.close()
        except Exception as e:
            print(e)
            sock.close()
            waitinglist.append(packname)
            break
        else:           
            time_end=time.time()
            print(out+'done!used time={:.3f} sec'.format(time_end-time_start))
            os.system(delete_command+os.path.join(tempdir,packname))
            break

runMainLoop=True
def listenforkeyboard():
    while True:
        aaa=input('[info] input <quit/exit> can quit:\n')
        print('you input:'+aaa)
        if aaa=='quit' or aaa=='exit':
            global runMainLoop
            runMainLoop=False
            break

a=''
while not (a=='Y' or a=='y'):
    prefix=getPrefix(source)
    print('{} prefixes had found'.format(len(prefix)))
    a=input('start sending?<Y or y> :')

t = threading.Thread(target=listenforkeyboard)
t.start() 

t = threading.Thread(target=tarFileThread)
t.setDaemon(True)
t.start() 

server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
server.bind(('0.0.0.0', port))
server.listen(5)
server.settimeout(1)


while runMainLoop:
    try:        
        sock, _ = server.accept()
    except:
        pass
    else:
        if len(waitinglist):
            packname=waitinglist.pop(0)
        else:
            packname=None
        t=threading.Thread(target=sendThread,args=(sock,packname))
        t.setDaemon(True)
        t.start()


    
print('[info] stop and exit! will delete temp file (or not)!')
print('[info] and all the thread will end (dont know what will happen)')
